org.keycloak.vault

## Enum AbstractVaultProviderFactory.AvailableResolvers

- java.lang.Object
- - java.lang.Enum<AbstractVaultProviderFactory.AvailableResolvers>
  - - org.keycloak.vault.AbstractVaultProviderFactory.AvailableResolvers

- All Implemented Interfaces:
    Serializable, Comparable<AbstractVaultProviderFactory.AvailableResolvers>
  Enclosing class:
    AbstractVaultProviderFactory

      protected static enum AbstractVaultProviderFactory.AvailableResolvers
      extends Enum<AbstractVaultProviderFactory.AvailableResolvers>

  Enum containing the available `VaultKeyResolver`s. The name used in the factory configuration must match the name one of the enum members.

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `FACTORY_PROVIDED` The format of the vault key is determined by the factory's `getFactoryResolver` implementation.
    `KEY_ONLY` Ignores the realm, only the vault key is used when retrieving a secret from the vault.
    `REALM_FILESEPARATOR_KEY` The realm is prepended to the vault key and they are separated by the platform file separator character.
    `REALM_UNDERSCORE_KEY` The realm is prepended to the vault key and they are separated by an underscore (`'_'`) character.

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static AbstractVaultProviderFactory.AvailableResolvers` | `valueOf(String name)` Returns the enum constant of this type with the specified name.
    `static AbstractVaultProviderFactory.AvailableResolvers[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### KEY_ONLY

          public static final AbstractVaultProviderFactory.AvailableResolvers KEY_ONLY

      Ignores the realm, only the vault key is used when retrieving a secret from the vault. This is useful when we want all realms to share the secrets, so instead of replicating entries for all existing realms in the vault one can simply use key directly and all realms will obtain the same secret.

    - #### REALM_UNDERSCORE_KEY

          public static final AbstractVaultProviderFactory.AvailableResolvers REALM_UNDERSCORE_KEY

      The realm is prepended to the vault key and they are separated by an underscore (`'_'`) character. If either the realm or the key contains an underscore, it is escaped by another underscore character.

    - #### REALM_FILESEPARATOR_KEY

          public static final AbstractVaultProviderFactory.AvailableResolvers REALM_FILESEPARATOR_KEY

      The realm is prepended to the vault key and they are separated by the platform file separator character. Not all providers might support this format but it is useful when a directory structure is used to group secrets per realm.

    - #### FACTORY_PROVIDED

          public static final AbstractVaultProviderFactory.AvailableResolvers FACTORY_PROVIDED

      The format of the vault key is determined by the factory's `getFactoryResolver` implementation. This allows for the customization of the vault key format by extending the factory and overriding the `getFactoryResolver` method. It is instantiated with a null resolver because we can't access the factory from the enum's static context.

  - ### Method Detail

    - #### values

          public static AbstractVaultProviderFactory.AvailableResolvers[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (AbstractVaultProviderFactory.AvailableResolvers c : AbstractVaultProviderFactory.AvailableResolvers.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static AbstractVaultProviderFactory.AvailableResolvers valueOf(String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `IllegalArgumentException` - if this enum type has no constant with the specified name
        `NullPointerException` - if the argument is null

Copyright © 2021 JBoss by Red Hat. All rights reserved.